<?php
/*
  $Id: bm_languages.php 189 2010-12-01 14:16:21Z Rob $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2010 osCommerce

  Released under the GNU General Public License
*/

  class bm_languages_usu {
    var $code = 'bm_languages_usu';
    var $group = 'boxes';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->title = MODULE_BOXES_LANGUAGES_USU_TITLE;
      $this->description = MODULE_BOXES_LANGUAGES_USU_DESCRIPTION;

      if ( defined('MODULE_BOXES_LANGUAGES_USU_STATUS') ) {
        $this->sort_order = MODULE_BOXES_LANGUAGES_USU_SORT_ORDER;
        $this->enabled = (MODULE_BOXES_LANGUAGES_USU_STATUS == 'True');

        $this->group = ((MODULE_BOXES_LANGUAGES_USU_CONTENT_PLACEMENT == 'Left Column') ? 'boxes_column_left' : 'boxes_column_right');
      }
    }

    function execute() {
      global $PHP_SELF, $lng,  $usu5_multi, $request_type, $oscTemplate, $language;

      if (substr(basename($PHP_SELF), 0, 8) != 'checkout') {
        if (!isset($lng) || (isset($lng) && !is_object($lng))) {
          include_once('includes/classes/language.php');
          $lng = new language;
        }

        if (count($lng->catalog_languages) > 1) {
          $data = '<div class="panel panel-default">' .
                  '  <div class="panel-heading">' . MODULE_BOXES_LANGUAGES_USU_BOX_TITLE . '</div>' .
                  '  <div class="panel-body text-center">' . $usu5_multi . '</div>' .
                  '</div>';

          $oscTemplate->addBlock($data, $this->group);
        }
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_BOXES_LANGUAGES_USU_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Languages Module', 'MODULE_BOXES_LANGUAGES_USU_STATUS', 'True', 'Do you want to add the module to your shop?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Placement', 'MODULE_BOXES_LANGUAGES_USU_CONTENT_PLACEMENT', 'Right Column', 'Should the module be loaded in the left or right column?', '6', '1', 'tep_cfg_select_option(array(\'Left Column\', \'Right Column\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_BOXES_LANGUAGES_USU_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_BOXES_LANGUAGES_USU_STATUS', 'MODULE_BOXES_LANGUAGES_USU_CONTENT_PLACEMENT', 'MODULE_BOXES_LANGUAGES_USU_SORT_ORDER');
    }
  }